# vasil@vasil.com

buildbinary(t : ref TagNode) : array of byte
{
	# start = version publicid charset strtbl body

	# 01 Version number - WBXML version 1.1 
	# 04 "-//WAPFORUM//DTD WML 1.1//EN" (WML 1.1) 
	# 03 charset=US-ASCII 

	b := array [] of {byte 16r01, byte 16r04, byte 16r03};

	# TODO:
	#
	# for now, just use a blank string table - all strings are inline (STR_I)
	#
	b = catbuf(b, array [] of {byte 0});
	b = catbuf(b, buildbinaryr(t));
	return b;
}

catbuf(b1, b2 : array of byte) : array of byte
{
	b := array [len b1 + len b2] of byte;
	b[0:] = b1;
	b[len b1:] = b2;
	return b;
}

buildbinaryr(t : ref TagNode) : array of byte
{
	ll : list of ref TagNode;
	b, b2 : array of byte;
	outtok := t.tag;

	if(outtok == LITERAL_C)
	{
		s := t.text;
		b = array [len s + 2] of byte;
		b[0] = byte STR_I;
		b[1:] = array of byte (s + "\0");
		return b;
	}

	if(t.attribs != nil)
		outtok |= TAG_ATTRIBUTE_PRESENT_MASK;
	if(t.subtags != nil)
		outtok |= TAG_CONTENT_PRESENT_MASK;

	b = array[1] of byte;
	b[0] = outtok;

	ll = t.attribs;
	while(ll != nil)
	{
		# TODO: everything is STR_I (inline string for now)
		#
		b2 = array [1] of byte;
		b2[0] = (hd ll).tag;
		b = catbuf(b, b2);
		if(len attrtagtostringlist((hd ll).tag) == 1)
		{
			b2 = array [1] of {byte STR_I};
			b = catbuf(b, b2);
			s := (hd ll).text;
			case int (hd ll).tag
			{
			int	ATT_HREF_HTTP or
			int	ATT_HREF_HTTPS or
			int	ATT_SRC_HTTP or
			int	ATT_SRC_HTTPS =>
				p := s;
				i := 0;
				while(i < len p - 2)
				{
					if(p[i:i+2] == "//")
					{
						s = p[i+2:];
						break;
					}
					i++;
				}
			}
			b2 = array of byte (s + "\0");
			b = catbuf(b, b2);
		}
		ll = tl ll;
	}

	if(t.attribs != nil)
		b = catbuf(b, array [1] of {END});

	ll = t.subtags;
	while(ll != nil)
	{
		b2 = buildbinaryr(hd ll);
		b = catbuf(b, b2);
		ll = tl ll;
	}

	if(t.subtags != nil)
		b = catbuf(b, array [1] of {END});

	return b;
}


