# vasil@vasil.com

listofstringtostring(ll : list of string) : string
{
	s := "";
	while(ll != nil)
	{
		s += hd ll + " ";
		ll = tl ll;
	}
	return s[0:len s - 1];
}

dumptree(ind : string, t : ref TagNode)
{
	sys->print("%s%s[%s]\n", ind, tagtostring(t.tag), t.text);
	s := t.attribs;
	while(s != nil)
	{
		a := hd s;
		sys->print("%s%x[%s]\n", ind, int a.tag, a.text);
		s = tl s;
	}
	ind += "  ";
	s = t.subtags;
	while(s != nil)
	{
		dumptree(ind, hd s);
		s = tl s;
	}
}

attrtagtostringlist(t : byte) : list of string
{
	s : string;
	ss : list of string;

	case int t
	{
	int ATT_ACCEPT_CHARSET => s = "accept-charset";
	int ATT_ACCESSKEY => s = "accesskey";
	int ATT_ALIGN => s = "align";
	int ATT_ALIGN_BOTTOM => ss = "align" :: "bottom" :: nil;
	int ATT_ALIGN_CENTER => ss = "align" :: "center" :: nil;
	int ATT_ALIGN_LEFT => ss = "align" :: "left" :: nil;
	int ATT_ALIGN_MIDDLE => ss = "align" :: "middle" :: nil;
	int ATT_ALIGN_RIGHT => ss = "align" :: "right" :: nil;
	int ATT_ALIGN_TOP => ss = "align" :: "top" :: nil;
	int ATT_ALT => s = "alt";
#	int ATT_CACHE_CONTROL_NO_CACHE	: con byte 16r64;
	int ATT_CLASS => s = "class";
	int ATT_COLUMNS => s = "columns";
	int ATT_CONTENT => s = "content";
#	int ATT_CONTENT_AVWW			: con byte 16r5C;
	int ATT_DOMAIN => s = "domain";
	int ATT_EMPTYOK_FALSE => ss = "emptyok" :: "false" :: nil;
	int ATT_EMPTYOK_TRUE => ss = "emptyok" :: "true" :: nil;
	int ATT_ENCTYPE => s = "enctype";
	int ATT_ENCTYPE_APP_X_W3_URLENCODED =>
		s = "application/x-www-form-urlencoded";
#	int ATT_ENCTYPE_MULTIPART_FORM_DATA	: con byte 16r61;
	int ATT_FORMAT => s = "format";
	int ATT_FORUA_FALSE => ss = "forua" :: "false" :: nil;
	int ATT_FORUA_TRUE => ss = "forua" :: "true" :: nil;
	int ATT_HEIGHT => s = "height";
	int ATT_HREF => s = "href";
	int ATT_HREF_HTTP => ss = "href=\"http://" :: nil;
	int ATT_HREF_HTTPS => ss = "href=\"https://" :: nil;
	int ATT_HSPACE => s = "hspace";
	int ATT_HTTP_EQUIV => s = "http-equiv";
#	int ATT_HTTP_EQUIV_CONTENT_TYPE	: con byte 16r5B;
#	int ATT_HTTP_EQUIV_EXPIRES		: con byte 16r5D;
	int ATT_ID => s = "id";
	int ATT_IVALUE => s = "ivalue";
	int ATT_INAME => s = "iname";
	int ATT_LABEL => s = "label";
	int ATT_LOCALSRC => s = "localsrc";
	int ATT_MAXLENGTH => s = "maxlength";
	int ATT_METHOD_GET => ss = "method" :: "get" :: nil;
	int ATT_METHOD_POST => ss = "method" :: "post" :: nil;
	int ATT_MODE_NOWRAP => ss = "mode" :: "nowrap" :: nil;
	int ATT_MODE_WRAP => ss = "mode" :: "wrap" :: nil;
	int ATT_MULTIPLE_FALSE => ss = "multiple" :: "false" :: nil;
	int ATT_MULTIPLE_TRUE => ss = "multiple" :: "true" :: nil;
	int ATT_NAME => s = "name";
	int ATT_NEWCONTEXT_FALSE => ss = "newcontext" :: "false" :: nil;
	int ATT_NEWCONTEXT_TRUE => ss = "newcontext" :: "true" :: nil;
	int ATT_ONENTERBACKWARD => s = "onenterbackward";
	int ATT_ONENTERFORWARD => s = "onenterforward";
	int ATT_ONPICK => s = "onpick";
	int ATT_ONTIMER => s = "ontimer";
	int ATT_OPTIONAL_FALSE => ss = "optional" :: "false" :: nil;
	int ATT_OPTIONAL_TRUE => ss = "optional" :: "true" :: nil;
	int ATT_PATH => s = "path";
	int ATT_SCHEME => s = "scheme";
	int ATT_SENDREFERER_FALSE => ss = "sendreferer" :: "false" :: nil;
	int ATT_SENDREFERER_TRUE => ss = "sendreferer" :: "true" :: nil;
	int ATT_SIZE => s = "size";
	int ATT_SRC => s = "src";
	int ATT_SRC_HTTP => ss = "src=\"http://" :: nil;
	int ATT_SRC_HTTPS => ss = "src=\"https://" :: nil;
	int ATT_ORDERED_TRUE => ss = "ordered" :: "true" :: nil;
	int ATT_ORDERED_FALSE => ss = "ordered" :: "false" :: nil;
	int ATT_TABINDEX => s = "tabindex";
	int ATT_TITLE => s = "title";
	int ATT_TYPE => s = "type";
	int ATT_TYPE_ACCEPT => ss = "type" :: "accept" :: nil;
	int ATT_TYPE_DELETE => ss = "type" :: "delete" :: nil;
	int ATT_TYPE_HELP => ss = "type" :: "help" :: nil;
	int ATT_TYPE_PASSWORD => ss = "type" :: "password" :: nil;
	int ATT_TYPE_ONPICK => ss = "type" :: "onpick" :: nil;
	int ATT_TYPE_ONENTERBACKWARD => ss = "type" :: "onenterbackward" :: nil;
	int ATT_TYPE_ONENTERFORWARD => ss = "type" :: "onenterforward" :: nil;
	int ATT_TYPE_ONTIMER => ss = "type" :: "ontimer" :: nil;
	int ATT_TYPE_OPTIONS => ss = "type" :: "options" :: nil;
	int ATT_TYPE_PREV => ss = "type" :: "prev" :: nil;
	int ATT_TYPE_RESET => ss = "type" :: "reset" :: nil;
	int ATT_TYPE_TEXT => ss = "type" :: "text" :: nil;
	int ATT_TYPE_VND => ss = "type" :: "vnd" :: nil;
	int ATT_VALUE => s = "value";
	int ATT_VSPACE => s = "vspace";
	int ATT_WIDTH => s = "width";
	int ATT_XML_LANG => s = "xml:lang";
	int ATT_XML_SPACE_PRESERVE => ss = "xml:space" :: "preserve" :: nil;
	int ATT_XML_SPACE_DEFAULT => ss = "xml:space" :: "default" :: nil;
	* => s = "UNKNOWN";
	}
	if(ss == nil)
		ss = s :: nil;
	return ss;
}

tagtostring(t : byte) : string
{
	s : string;
	case int t
	{
	int	LITERAL_C	=> s = "pcdata";
	int TAG_A		=> s = "a";
	int TAG_ANCHOR	=> s = "anchor";
	int TAG_ACCESS	=> s = "access";
	int TAG_B		=> s = "b";
	int TAG_BIG		=> s = "big";
	int TAG_BR		=> s = "br";
	int TAG_CARD	=> s = "card";
	int TAG_DO		=> s = "do";
	int TAG_EM		=> s = "em";
	int TAG_FIELDSET	=> s = "fieldset";
	int TAG_GO		=> s = "go";
	int TAG_HEAD	=> s = "head";
	int TAG_I		=> s = "i";
	int TAG_IMG		=> s = "img";
	int TAG_INPUT	=> s = "input";
	int TAG_META	=> s = "meta";
	int TAG_NOOP	=> s = "noop";
	int TAG_P		=> s = "p";
	int TAG_POSTFIELD	=> s = "postfield";
	int TAG_PRE		=> s = "pre";
	int TAG_PREV	=> s = "prev";
	int TAG_ONEVENT	=> s = "onevent";
	int TAG_OPTGROUP	=> s = "optgroup";
	int TAG_OPTION	=> s = "option";
	int TAG_REFRESH	=> s = "refresh";
	int TAG_SELECT	=> s = "select";
	int TAG_SETVAR	=> s = "setvar";
	int TAG_SMALL	=> s = "small";
	int TAG_STRONG	=> s = "strong";
	int TAG_TABLE	=> s = "table";
	int TAG_TD		=> s = "td";
	int TAG_TEMPLATE	=> s = "template";
	int TAG_TIMER	=> s = "timer";
	int TAG_TR		=> s = "tr";
	int TAG_U		=> s = "u";
	int TAG_WML		=> s = "wml";
	* => s = "UNKNOWN";
	}
	return s;
}
