# vasil@vasil.com

parsebinary(b : array of byte) : (ref TagNode)
{
	# start	= version publicid charset strtbl body
	i := 0;
	n, publicid, charset, stringtablen : int;

	version := b[i];
	i++;
	if(b[i] == byte 0)
	{
		i++;
		(n, publicid) = multibytetoint(b[i:]);
		# TODO:
		# defer the lookup of publicid in string table until after the
		# string table is parsed
		# publicidstr := string stringtable[publicid:];
		i += n;
	}
	else
	{
		(n, publicid) = multibytetoint(b[i:]);
		i += n;
	}
	(n, charset) = multibytetoint(b[i:]);
	i += n;

	(n, stringtablen) = multibytetoint(b[i:]);
	i += n;
	stringtable = b[i:i + stringtablen];
	i += stringtablen;
	(j, t) := parsebinaryr(b[i:]);
	i += j;
	return t;
}

parsebinaryr(b : array of byte) : (int, ref TagNode)
{
	i := 0;
	tok := b[i];
	i++;
	t := ref TagNode;
	t.handle = "";
	t.tag = tok & TAG_MASK;
	t.text = tagtostring(t.tag);
	t.attribs = nil;
	t.subtags = nil;

	if(tok == STR_T || tok == STR_I)
	{
		i--;
		t.tag = LITERAL_C;
		(n, s) := parsebinaryvalue(b[i:]);
		t.text = s;
		i += n;
		return (i, t);
	}

	if(int (tok & TAG_ATTRIBUTE_PRESENT_MASK))
	{
		attrtok := b[i];
		while(attrtok != END)
		{
			(n, attr) := parsebinaryattr(b[i:]);
			i += n;
			t.attribs = addtoendoflist(t.attribs, attr);
			attrtok = b[i];
		}
		i++;
	}

	if(int (tok & TAG_CONTENT_PRESENT_MASK))
	{
		subtok := b[i];
		while(subtok != END)
		{
			(n, sub) := parsebinaryr(b[i:]);
			t.subtags = addtoendoflist(t.subtags, sub);
			i += n;
			subtok = b[i];
		}
		i++;
	}

	return (i, t);
}

parsebinaryattr(b : array of byte) : (int, ref TagNode)
{
	i := 0;
	tok := b[i];
	i++;
	t := ref TagNode;
	t.handle = "";
	t.tag = tok;
	v := attrtagtostringlist(t.tag);
	if(tl v != nil)
		t.text = hd tl v;
	(n, s) := parsebinaryvalue(b[i:]);
	i += n;
	if(s != nil)
		t.text += s;
	t.attribs = nil;
	t.subtags = nil;

	return (i, t);
}

parsebinaryvalue(b : array of byte) : (int, string)
{
	i := 0;
	end : int;
	s : string;
	ret := "";
	done := 0;
	while(!done)
	{
		case int b[i]
		{
		int STR_I =>
			i++;
			end = i;
			while(b[end] != byte 0)
				end++;
			s = string b[i:end];
			ret += s;
			i += len s + 1;
		int STR_T =>
			i++;
			(n, index) := multibytetoint(b[i:]);
			i += n;
			end = index;
			while(stringtable[end] != byte 0)
				end++;
			s = string stringtable[index:end];
			ret += s;
		* =>
			s = valuetostring(b[i]);
			if(s != nil)
			{
				i++;
				ret += s;
			}
			else
				done = 1;
		}
		if(i >= len b)
			done = 1;
	}
	return (i, ret);
}

valuetostring(b : byte) : string
{
	s := "";
	case int b
	{
		int VALUE_COM =>	s = ".com/";
		int VALUE_EDU =>	s = ".edu/";
		int VALUE_NET =>	s = ".net/";
		int VALUE_ORG =>	s = ".org/";
		int VALUE_ACCEPT =>	s = "accept";
		int VALUE_BOTTOM =>	s = "bottom";
		int VALUE_CLEAR =>	s = "clear";
		int VALUE_DELETE =>	s = "dealte";
		int VALUE_HELP =>	s = "help";
		int VALUE_HTTP =>	s = "http://";
		int VALUE_HTTP_WWW =>	s = "http://www.";
		int VALUE_HTTPS =>	s = "https://";
		int VALUE_HTTPS_WWW =>	s = "https://www.";
		int VALUE_MIDDLE =>	s = "middle";
		int VALUE_NOWARP =>	s = "nowrap";
		int VALUE_ONENTERBACKWARD =>	s = "onenterbackward";
		int VALUE_ONENTERFORWARD =>		s = "onenterforward";
		int VALUE_ONPICK =>	s = "onpick";
		int VALUE_ONTIMER =>	s = "ontimer";
		int VALUE_OPTIONS =>	s = "options";
		int VALUE_PASSWORD =>	s = "password";
		int VALUE_RESET =>	s = "reset";
		int VALUE_TEXT =>	s = "text";
		int VALUE_TOP =>	s = "top";
		int VALUE_UNKNOWN =>	s = "unknown";
		int VALUE_WRAP =>	s = "wrap";
		int VALUE_WWW =>	s = "www.";
	}
	return s;
}