# vasil@vasil.com

implement WmlBro;

include "sys.m";
include "draw.m";
include "string.m";
include "tk.m";
include "wmlib.m";
include "url.m";
include "wmlbro.m";
include "wml.m";
include "wbmp.m";
include "webgrab.m";

sys:	Sys;
draw:	Draw;
str:	String;
tk:		Tk;
wmlib:	Wmlib;
url:	Url;
web:	Webgrab;

ParsedUrl: import url;
stderr: ref Sys->FD;
toplevel: ref Tk->Toplevel;
debug := 0;
debugpanel := 0;

WmlBro: module
{
	init:	fn(ctxt: ref Draw->Context, argv: list of string);
};

WebRequest : adt
{
	ttype : byte;
	contype  : int;
	tag : string;
	data : array of byte;
	u : ParsedUrl;
};

Variable : adt
{
	name, value : string;
};

# TODO:
#
#CacheEntry : adt
#{
#	url : ParsedUrl;
#	t : ref TagNode;
#	contype : int;
#};

include "dumptagtree.b";
include "tagnode.b";
include "wmldtd.b";
include "urlcode.b";
include "loadfile.b";
include "tkcmd.b";

timerchan : chan of (byte, byte);
webchan : chan of ref WebRequest;
nrchan : chan of int;

#TODO: cache		: list of CacheEntry;
history		: list of string;
variables	: list of ref Variable;
currentcard : ref TagNode;
currenttemplate : ref TagNode;
currentdeck	: ref TagNode;
currentlinks: list of ref TagNode;
currentlink	: ref TagNode;
isforward := 0;
isbackward := 0;
inoption := 0;
inanchor := 0;
currentselect := "";
font : string;
justify := "w";
packcmd := "";
snarf := "";
wmloflastdeck := "";
baseurl : ParsedUrl;
lcount := 0;
refcount := 0;
ccid := byte 0;

T_UNKNOWN,
T_HTML,
T_WML,
T_WMLC,
T_WMLS,
T_WMLSC,
T_WBMP,
T_BMP,
T_DIS,
T_TXT
: con iota;

errordeck := array [] of
{
	byte 16r01,	byte 16r04, byte 16r03,	byte 16r01,	# '01' is the string table length
	byte '!',	byte 16r00,	byte 16r7f,	byte 16re7, # null terminated string in table 
	byte 16r55,	byte 16r03,	byte 16r31,	byte 16r00,
	byte 16r36,	byte 16r03,	byte 16r45,	byte 16r72,
	byte 16r72,	byte 16r6f,	byte 16r72,	byte 16r00,
	byte 16r01,	byte 16r60,	byte 16r83, byte 16r00,	# the 0x83 is a STR_T	
	byte 16r01,	byte 16re8,	byte 16r38,	byte 16r18,
	byte 16r03,	byte 16r42,	byte 16r61,	byte 16r63,
	byte 16r6b,	byte 16r00,	byte 16r01,	byte 16r32,
	byte 16r01,	byte 16r01,	byte 16r01
};

init(ctxt: ref Draw->Context, argv: list of string)
{
	s := "";
	dtdinit();
	done := 0;
	last := -1;

	sys		= load Sys		Sys->PATH;
	draw	= load Draw		Draw->PATH;
	str		= load String	String->PATH;
	tk		= load Tk		Tk->PATH;
	wmlib	= load Wmlib	Wmlib->PATH;
	url		= load Url		Url->PATH;
	web		= load Webgrab Webgrab->PATH;
	web->modinit();
	web->readconfig();

	stderr = sys->fildes(2);
	url->init();
	wmlib->init();

	(t, winctl) := wmlib->titlebar(ctxt.screen, "", "WMLBro", Wmlib->Appl);
	toplevel = t;
	cmd := chan of string;
	tk->namechan(t, cmd, "user");

	(there, nil) := sys->stat("/net/cs");
	if (there == -1)
	{
		cs := load WmlBro "/dis/lib/cs.dis";
		if (cs != nil)
			cs->init(nil, nil);
	}

#TODO:
# all widgets of a line will go on it's own frame
# this will allow us better control of layout
#	tkcmd("frame .f.doc.line0");
#	tkcmd("pack .f.doc.line0 -expand 1");


	tkcmd("bind . <Key> {send user k %s}");
	tkcmd("bind . <ButtonRelease-1> {focus .}");
	tkcmd("bind .Wm_t <ButtonRelease-1> +{focus .}");

	tkcmd("frame .f -relief raised -bd 2");
#TODO: ?
# scrollbars dont work on frames!?
#	tkcmd("scrollbar .f.scrolly -orient vertical -command {.f yview}");
#	tkcmd("pack .f.scrolly -side right -fill y");
	tkcmd("frame .f.doc -relief sunken -bd 2 -width 350 -height 300");
	tkcmd("frame .f.f");
	tkcmd("entry .f.f.e -width 25w");
	tkcmd("bind .f.f.e <Button-3> +{send user tbp %x}");
	tkcmd("bind .f.f.e <Motion-Button-3> {send user bm %x}");
	tkcmd("bind .f.f.e <ButtonRelease-3> +{send user bp %x}");
	tkcmd("menu .f.f.e.menu");
	tkcmd(".f.f.e.menu add command -label Put -command {send user snarfput}");
	tkcmd(".f.f.e.menu add command -label Get -command {send user snarfget}");
	tkcmd(".f.f.e.menu add command -label Bookmark -command {send user bookmark}");
#	if(debug)
	tkcmd(".f.f.e.menu add command -label Source -command {send user dumpwml}");
		
	tkcmd("bind .f.f.e.menu <ButtonRelease> {%W tkMenuButtonUp %x %y}");
	tkcmd("bind .f.f.e <Button-2> {.f.f.e.menu post %X %Y}");
	tkcmd("bind .f.f.e <Key-\n> {send user go entry}");
	tkcmd("button .f.f.b -text {Go} -command {send user go entry}");
	tkcmd("canvas .f.f.nr -width 40 -height 16 -bg white");

	tkcmd("label .f.l -text {WMLBro 0.0}");
	tkcmd("frame .f.f2");
	tkcmd("button .f.f2.bp -text {Prev} -command {send user prev}");
	tkcmd("button .f.f2.bm -text {Bookmarks} -command {send user bookmarks}");

	tkcmd("pack .f.f.e .f.f.b .f.f.nr -side left");
	tkcmd("pack .f.f2.bp .f.f2.bm -side left");
	tkcmd("pack .f.doc -fill both -expand 1");
	tkcmd("pack .f.f .f.l .f.doc .f.f2");
	tkcmd("pack .f -fill both -expand 1");
	tkcmd("pack propagate . 0");
	tkcmd("update");

	argv = tl argv;
	while(argv != nil)
	{
		case (hd argv)
		{
		"-d" =>	debug = 1;
		"-dd" => debug = 2;
		* => s = hd argv;
		}
		argv = tl argv;
	}

	timerchan = chan of (byte, byte);
	webchan = chan of ref WebRequest;
	nrchan = chan of int;

	setvariable("!font_normal", "/fonts/lucidasans/unicode.8.font");
	setvariable("!historysize", "20");
	setvariable("!cachesize", "20");
	font = getvariable("!font_normal");
	readconfig();

	# Lots of WAP-enabled sites will respond with HTML unless they know
	# a well-known WML User-Agent is hitting them.
	# So we'll have to lie.
	#
	web->setuseragent("UP.Browser/3.1-UPG1 UP.Link/3.2");

#	baseurl.scheme = Url->NOSCHEME;

#	can't get defaulting to HTTP schemes to work
#	baseurl.scheme = Url->NOSCHEME;
#	baseurl.scheme = Url->HTTP;
#	baseurl.user = nil;
#	baseurl.passwd = nil;

	baseurl.scheme = Url->FILE;
	baseurl.pstart = "/";

	if(s != nil)
		browseto(s);

	while(1)
	{
	alt
	{
	wr := <- webchan =>
		# TODO: match the response to the request!
		nrchan <- = 1;	# stop nightrider
		if(debug)
			sys->print("webget done, id: %s\n", (ref wr.u).tostring());
		refcount--;

		case (int wr.ttype)
		{
		int TAG_IMG =>
			if(wr.contype != T_HTML && wr.data != nil)
			{
				# TODO: support images within anchor tags
				# TODO: check to make sure it's a wap/wbmp image
				wbmp := load Wbmp Wbmp->PATH;
				wbmp->modinit();
				widget := wbmp->wbmp(wr.data, toplevel, wr.tag, lcount);
				lcount++;
				s = "pack " + widget + " -fill both -expand 1 ; update";
				tkcmd(s);
				nil = wbmp;
			}
		int TAG_WML =>
			# TODO: handle other content types appropriately (the wr.contype field)
			pushhistory((ref (wr.u)).tostring());
			if(wr.data == nil)
			{
				wr.contype = T_WMLC;
				wr.data = builderror("no data.");
			}
			else if(wr.contype == T_HTML)
			{
				wmloflastdeck = string wr.data;
				wr.contype = T_WMLC;
				wr.data = builderror("HTML not supported.");
			}
			else
				wmloflastdeck = string wr.data;
			tree := processdeck(wr);
			if(wr.u.frag != nil)
				tree = findcardindeck(tree, wr.u.frag);
			if(tree != nil)
				freshcard(tree);
		}

	(b, id) := <- timerchan =>
		{
			refcount--;
			if(id >= ccid)
			{
				href := findonevent(currentcard, b);
				if(debug)
					sys->print("timer done: %s\thref:[%s]\n", hd attrtagtostringlist(b), href);
				if(href != nil)
				{
					href = escape(href);
					browseto(href);
				}
			}
			else
				if(debug)
					sys->print("event for old card: %d < %d\n", int id, int ccid);
		}
	s = <- cmd =>
		{
			if(debug)
				sys->print("cmd: %s\n", s);
			(n, words) := sys->tokenize(s, " \t");
			case hd words
			{
			* =>
				if(debug)
					sys->print("cmd not handled: %s\n", s);
			"k" =>
				if(hd tl words == "68") # "shift + d"
					toggledebug();

			# Tad Hunt's scrollable entry widget
			"bp" =>
				last = int hd tl words;
			"bm" =>
				p := int hd tl words;
				if(p < last)
					s = "-1u";
				else
					s = "1u";
				last = p;
				tkcmd(".f.f.e xview scroll "+s+"; update");

			"dumpvars" =>	dumpvars();
			"dumphist" =>	dumphist();
			"dumpcache" =>	dumpcache();
			"dumpwml" =>	sys->print("\n%s\n\n", wmloflastdeck);
			"snarfput" =>
				{
					if((snarf = string loadfile(openfile("/chan/snarf"))) != nil)
					{
						snarf = escape(snarf);
						seturlfield(snarf);
					}
				}
			"snarfget" =>
				{
					snarf = tkcmd(".f.f.e get 0 end");
					if ( (sfd := sys->open("/chan/snarf", Sys->OWRITE)) != nil )
						sys->fprint(sfd, "%s", snarf);
				}
			"bookmarks" =>
				browseto("file://localhost/" + getvariable("!bookmarks"));
			"bookmark" =>
				{
					if(snarf != nil)
					{
						addbookmark(snarf);
					}
				}
			"inputfocusout" =>
				{
					tree := findhandle(hd tl words);
					if(tree != nil)
					{
						var := tree.getattr(ATT_NAME);
						value := tkcmd(tree.handle + " get 0 end");
						if(var != nil)
							setvariable(var, value);
					}
				}
			"pick"=>
				{
					tree := findhandle(hd tl words);
					if(tree != nil)
					{
						# TODO: process iname and ivalue
						index := tkcmd(tree.handle + ".l curselection");
						optiontag := tree.getnthchild(int index);
						var := tree.getattr(ATT_NAME);
						value := optiontag.getattr(ATT_VALUE);
						if(var != nil)
							setvariable(var, value);
						fname := findhref(optiontag);
						if(fname != "")
							browseto(fname);
					}
				}
			"prev" =>
				browseto("PREV");
			"click" =>
				sys->print("%s\n", s);
				# TODO: add support for images inside anchor tags.
				# trick is that we have to bind a mouse click event to
				# a tk widget we're not pointing to anymore.
			"go" =>
				{
					fname : string;
					if(hd tl words == "entry")
					{
						fname = tkcmd(".f.f.e get");
					}
					else
					{
						fname = escape(findhref(findhandle(hd tl words)));
					}
					browseto(fname);
				}
			}
		}
	s = <- winctl =>
		{
			if(debug)
				sys->print("winctl: %s\n", s);
			if(s == "exit")
				done = 1;
			else
				wmlib->titlectl(t, s);
		}
	}
	if(done == 1)
	{
		if(!refcount)
			exit;
	}
	}
}

# TODO: this is horrid, please fix
# match the event with either an onevent tag, or an attribute of the card that
# handles the event. why would they spec that kind of redundancy?

findonevent(t : ref TagNode, ttype : byte) : string
{
	a : ref TagNode;

	if(t == nil)
		return nil;

	case int t.tag
	{
	int TAG_CARD =>
		s := t.getattr(ttype);
		if(s != nil)
			return s;
		# check each onevent subtag
		for(i := 0; i < len t.subtags; i++)
		{
			sub := t.getnthchild(i);
			if(sub.tag == TAG_ONEVENT)
				href := findonevent(sub, ttype);
			if(href != nil)
				return href;
		}
	int TAG_ONEVENT =>
		for(i := 0; i < len t.attribs; i++)
		{
			a = t.getnthattr(i);
			case int a.tag
			{
			int ATT_TYPE_ONTIMER =>
				if(ttype == ATT_ONTIMER)
					return findhref(t);
			int ATT_TYPE_ONENTERBACKWARD =>
				if(ttype == ATT_ONENTERBACKWARD)
					return findhref(t);
			int ATT_TYPE_ONENTERFORWARD =>
				if(ttype == ATT_ONENTERFORWARD)
					return findhref(t);
			# int ATT_TYPE_ONPICK =>
			int ATT_TYPE =>
				case a.text
				{
				"ontimer" =>
					if(ttype == ATT_ONTIMER)
						return findhref(t);
				"onenterforward" =>
					if(ttype == ATT_ONENTERFORWARD)
						return findhref(t);
				"onenterbackward" =>
					if(ttype == ATT_ONENTERBACKWARD)
						return findhref(t);
				}
			}
		}
	}
	return nil;
}

newcontext()
{
	# TODO: what else needs to happen here?
	if(debug)
		sys->print("new context\n");
	history = nil;
	clearvariables();
	# cache = nil;
}

dumpvars()
{
	vv := variables;
	while(vv != nil)
	{
		sys->print("%s\t%s\n", (hd vv).name, (hd vv).value);
		vv = tl vv;
	}
}

dumphist()
{
	hh := history;
	while(hh != nil)
	{
		sys->print("%s\n", hd hh);
		hh = tl hh;
	}
}

dumpcache()
{
	# TODO
}

clearvariables()
{
	vv := variables;
	variables = nil;
	while(vv != nil)
	{
		var := hd vv;
		# save the system parameters of config file
		if(var.name[0] == '!')
			variables = var :: variables;
		vv = tl vv;
	}
}

resetcurrents()
{
	justify = "w";
	# currenttemplate = nil;
	# currentdeck = nil;
	currentcard = nil;
	currentlink  = nil;
	currentlinks  = nil;
	currentselect = nil;
}

seturlfield(s : string)
{
	tkcmd(".f.f.e delete 0.0 end");
	tkcmd(".f.f.e insert insert '" + s);
	tkcmd("update");
}

escapeparen(s : string) : (int, string)
{
	ret := "";
	i := 1;
	if(s[i] == '$')
		return (2, "$");	# "$$" => "$"
	if(s[i] == '(')
		i++;
	end := i;
loop:
	while(end < len s)
		case s[end]
		{
		'a' to 'z' or
		'A' to 'Z' or
		'_' => 	end++;
		* =>	break loop;
		}

	ret += getvariable(s[i:end]);

	# TODO - this assumes a variable with a ':' conv spec with always be enclosed in ()!
	if(end < len s && s[end] == ':')
	{
		#TODO: unesc? noesc?
		# for now, just skip the conversion spec
		if(debug)
			sys->print("escape conversion not yet supported: %s\n", s[end:]);
		while(end < len s && s[end] != ')')
			end++;
	}
	if(end < len s && s[end] == ')')
		end++;
	return (end, ret);
}

escape(s : string) : string
{
	s = entities(s);
	ret := "";
	i := 0;
	end := 0;
	while(i < len s)
	{
		case (s[i])
		{
		'$' =>
			(n, v) := escapeparen(s[i:]);
			ret += v;
			i += n;
		* =>
			ret += s[i:i+1];
			i++;
		}
	}
	return ret;
}	

hexstringtoint(s : string) : int
{
	i := 0;
	val := 0;
	while(i < len s)
	{
		val <<= 4;
		case s[i]
		{
		'0' to '9' =>	val |= int s[i];
		'a' or 'A' =>	val |= 10;
		'b' or 'B' =>	val |= 11;
		'c' or 'C' =>	val |= 12;
		'd' or 'D' =>	val |= 13;
		'e' or 'E' =>	val |= 14;
		'f' or 'F' =>	val |= 15;
		}
		i++;
	}
	return val;
}

entities(s : string) : string
{
	ret := "";
	c, v : int;	
	i := 0;	
	j := 0;	
	while(i < len s)
	{
		case (s[i])
		{
		'&' =>
			if(debug)
				sys->print("entity: %s\n", s[i:]);
			j = i + 1;
			while(j < len s && s[j])
			{
				if(s[j] == ';')
					break;
				j++;
			}
			if(j < len s && s[j] == ';')
			{
				if(s[i+1] == '#')
				{
					if(i + 2 < len s)
					{
						c = s[i + 2];
						if(c == 'x' || c == 'X')
							v = hexstringtoint(s[i + 3 : j]);	#hex
						else
							v = int s[i + 2 : j];				#decimal
						ret[len ret] = v;
					}
				}
				else
				{
					case s[i+1:j]
					{
					"amp" =>	ret += "&";
					"gt" =>		ret += ">";
					"lt" =>		ret += "<";
					"quot" =>	ret += "\"";
					"apos" =>	ret += "`";
					"shy" =>	ret += "-";
					"nbsp" =>	ret += " ";
					}
				}
				i = j;
			}
			else
			{
				ret += s[i:i+1];
			}
		'\r' or '\n' or '\t' =>
			;
		* =>
			ret += s[i:i+1];
		}
		i++;
	}
	return ret;
}

allbutlast(ll : list of string) : list of string
{
	if(len ll == 2)
		return hd ll :: nil;
	return hd ll :: allbutlast(tl ll);
}

pushhistory(s : string)
{
	history = s :: history;
	hs := int getvariable("!historysize");
	if(len history > hs)
	{
		history = allbutlast(history);
	}
}

goprev() : string
{
	fname := "";
	if(history != nil)
	{
		history = tl history;
		if(history != nil)
		{
			fname = hd history;
			history = tl history;
		}
	}
	return fname;
}

getvariable(s : string) : string
{
	v : ref Variable;
	vv := variables;
	while(vv != nil)
	{
		v = hd vv;
		if(debug > 1)
			sys->print("getvariable comparing: %s %s\n", s, v.name);
		if(v.name == s)
		{
			return v.value;
		}
		vv = tl vv;
	}
	return nil;
}

setvariable(name, value : string)
{
	v : ref Variable;
	vv := variables;
	while(vv != nil)
	{
		v = hd vv;
		if(v.name == name)
		{
			v.value = value;
			if(debug)
				sys->print("var: %s value: %s\n", v.name, v.value);
			return;
		}
		vv = tl vv;
	}
	v = ref Variable;
	v.value = value;
	v.name = name;
	if(debug)
		sys->print("new var: %s value: %s\n", v.name, v.value);
	variables = v :: variables;
}

dotask(t : ref TagNode) : string
{

	# TODO:
	#
	# queries should be applied to the URL string *before* the fragment.
	# how are we going to do this?
	# (see wml/event.wml)

	query := "";
	case int t.tag
	{
	int TAG_REFRESH or
	int TAG_GO =>
		{
			if(t.tag == TAG_REFRESH)
				query = "REFRESH";
			ss := t.subtags;
			while(ss != nil)
			{
				sub := hd ss;
				case int sub.tag
				{
				int TAG_POSTFIELD =>
					name := sub.getattr(ATT_NAME);
					value := sub.getattr(ATT_VALUE);
					query += "&" + name + "=" + value;
				int TAG_SETVAR =>
					name := sub.getattr(ATT_NAME);
					value := sub.getattr(ATT_VALUE);
					setvariable(name, value);
				}
				ss = tl ss;
			}
			if(t.tag == TAG_GO && query != nil)
				query[0] = '?';
		}
	int TAG_PREV =>
		query = "PREV";
	}
	if(debug)
		sys->print("dotask in tag: %s returning: %s\n", tagtostring(t.tag), query);
	return query;
}

findhref(t : ref TagNode) : string
{
	s := "";
	if(t == nil)
	{
		sys->fprint(stderr, "findhref got nil!\n"); # TODO: track this one down
		return nil;
	}
	case int t.tag
	{
	int TAG_OPTION =>
		s = t.getattr(ATT_ONPICK);
		if(s == nil)
		{
			sub := t.getchild(TAG_ONEVENT);
			if(sub != nil)
				s = findhref(sub);
		}
	int TAG_PREV or
	int TAG_NOOP or
	int TAG_REFRESH or
	int TAG_GO =>
		for(i := 0; i < len t.attribs; i++)
		{
			a := t.getnthattr(i);
			case int a.tag
			{
			int ATT_HREF_HTTPS or
			int ATT_HREF_HTTP or
			int ATT_HREF =>
				s = a.text;
			}
		}
		s += dotask(t);
	int TAG_A =>
		for(i := 0; i < len t.attribs; i++)
		{
			a := t.getnthattr(i);
			case int a.tag
			{
			int ATT_HREF_HTTPS or
			int ATT_HREF_HTTP or
			int ATT_HREF =>
				s = a.text;
			}
		}
	int TAG_ANCHOR or
	int TAG_DO or
	int TAG_ONEVENT =>
		{
			ll := t.subtags;
			while(ll != nil)
			{
				s = findhref(hd ll);
				if(s != nil)
					break;
				ll = tl ll;
			}
		}
		# this is an ugly special case to handle
		#
		#    <do type="prev" label=" "><noop/></do>
		if(s == nil && t.tag == TAG_DO)
		{
			if((t.getattr(ATT_TYPE_PREV) != nil) || (t.getattr(ATT_TYPE) == "prev"))
				s = "PREV";
		} 
	}
	if(debug)
		sys->print("findhref in tag: %s returning: %s\n", tagtostring(t.tag), s);
	return s;
}

findhandle(h : string) : ref TagNode
{
	ll := currentlinks;
	while(ll != nil)
	{
		if((hd ll).handle == h)
		{
			return (hd ll);
		}
		ll = tl ll;
	}
	return nil;
}

findcardindeck(t : ref TagNode, id : string) : ref TagNode
{
	ss := t.subtags;

	while(ss != nil)
	{
		card := hd ss;
		if(card.tag == TAG_TEMPLATE)
		{
			currenttemplate = card;
		}
		else if(card.getattr(ATT_ID) == id)
		{
			return card;
		}
		ss = tl ss;
	}
	return nil;
}

builderror(s : string) : array of byte
{
	if(len s > 127)
		s = s[0:127];
	b := array [len s + len errordeck - 1] of byte;
	b[0:] = errordeck[0:3];
	b[3] = byte (len s + 1);
	b[4:] = array of byte s;
	b[4 + len s:] = errordeck[5:];
	return b;
}

browseto(fname : string)
{
	u : ParsedUrl;
	us : string;

	if(debug)
		sys->print("browseto, fname: %s\n", fname);

	isbackward = 0;
	isforward = 1;

	case (fname)
	{
	"REFRESH" =>
		isforward = 0;
		isbackward = 0;
		freshcard(currentdeck);
		return;
	"PREV" =>
		isbackward = 1;
		isforward = 0;
		fname = goprev();
		# fall through!
	}

	# card urls within same deck
	if(fname != nil && fname[0] == '#')
	{
		u = *(url->makeurl(fname));
		u = applyrelative(u);
		us = (ref u).tostring();
		pushhistory(us);
		snarf = us;
		seturlfield(snarf);
		t := findcardindeck(currentdeck, fname[1:]);
		if(t != nil)
			freshcard(t);
		return;
	}

	# from "PREV" and deck urls
	u = *(url->makeurl(fname));
	u = applyrelative(u);
	us = (ref u).tostring();
	snarf = us;
	seturlfield(snarf);
	refcount++;
	spawn requestthread(u, nil, TAG_WML);
}

processdeck(wr : ref WebRequest) : ref TagNode
{
	t : ref TagNode;
	wp := load WmlLib WmlLib->PATH;
	wp->modinit();
	if(wr.contype == T_WMLC)
	{
		t = wp->parsebinary(wr.data);
	}
	else
	{
		t = wp->parsetext(string wr.data);
	}
	if(debug > 1)
		wp->dumptree("", t);
	nil = wp;
	currentdeck = t;
	return t;
}

freshcard(t : ref TagNode)
{
	resetcurrents();
	ccid++;
	tkcmd("destroy .f.doc");
	tkcmd("frame .f.doc -relief sunken -bd 2");
	packcmd = "pack ";
	drawcard(t);
	if(justify != nil)
		packcmd += "-anchor " + justify;
	packcmd += " -side top";
	tkcmd(packcmd);
	tkcmd("pack .f.doc -fill both -expand 1");
	tkcmd("pack .f.f .f.l .f.doc .f.f2");
	tkcmd("pack .f -fill both -expand 1");
	tkcmd("pack propagate . 0");
	tkcmd("update");
}

lookincache() : int
{
	# TODO:
	return 0;
}

parsecontype(s : string) : int
{
	i := T_UNKNOWN;
	case s
	{
	*							=> i = T_UNKNOWN;
	"text/plain"				=> i = T_TXT;
	"text/html"					=> i = T_HTML;
	"text/vnd.wap.wml"			=> i = T_WML;
	"application/vnd.wap.wmlc"	=> i = T_WMLC;
	"text/vnd.wap.wmlscript"	=> i = T_WMLS;
	"application/vnd.wap.wmlscriptc"	=> i = T_WMLSC;
	"application/vnd.inferno.dis"		=> i = T_DIS; # sorry, i couldn't resist
	"image/vnd.wap.wbmp"		=> i = T_WBMP;
	"image/x-ms-bmp"			=> i = T_BMP;
	"image/x-xbitmap"			=> i = T_BMP;
	}
	return i;
}

# TODO:
#
# different content types should be handled in different ways. this should be done
# here but it's not. .wmlc files should be binary parsed then displayed, whereas .wml
# is text parsed. .htm* should be ignored. .wbmp should be displayed alone. perhaps
# .txt as well. .bmp? .wmlscript/.wmlsc? maybe we could even add support for loading
# and running .dis files that implement the interace to sh. (to be safe maybe we can
# sandbox them in their own namespace before running them?
#

requestthread(u : ParsedUrl, s : string, ttype : byte)
{
	wr := ref WebRequest;
	wr.tag = s;
	wr.ttype = ttype;
	#wr.fname = fname;
	wr.u = u;
	wr.contype = T_UNKNOWN;

	spawn nightrider();
	if(isurl(ref u))
	{
		if(lookincache())
		{
			# TODO
			wr.data = nil;
		}
		else
		{
			if(debug)
				sys->print("requesting: %s\n", (ref u).tostring());
			body := "";
			(err, bytes, realurl) := web->httpget(ref u);
			contype := web->getlastcontype();
			if(debug)
				sys->print("content type: %s\n", contype);

			# webgrab internally may have been redirected by the server
			# several times, we want to the base url to be set to the actual
			# url we've received

			if(realurl != nil)
				u = *realurl;

			wr.data = bytes;
			wr.contype = parsecontype(contype);

			if(debug == 2)
				sys->print("content received:\n%s\n\n", string wr.data);
			nil = web;
		}
	}
	else
	{
		ff : string;
		(ff, u) = fileof(u);
		wr.data = loadfile(openfile(ff));
		wr.u = u;
		wr.contype = T_WML;			# TODO: support others for files
	}

	# moved it to here from browseto() coz of frag
	if(ttype != TAG_IMG && wr.data != nil)
		baseurl = u;

	webchan <- = wr;
}

timertask(ttype: byte, id : byte, msec : int)
{
	sys->sleep(msec);
	timerchan <- = (ttype, id);
}

eventfired(ttype : byte)
{
	if(debug)
		sys->print("eventfired got: %s\n", hd attrtagtostringlist(ttype));
	refcount++;
	spawn timertask(ttype, ccid, 0);
}

drawcard(tree : ref TagNode)
{
	s : string;

	if(debug > 1)
		sys->print("drawcard: %s\n", tagtostring(tree.tag));	

	case int tree.tag
	{
# TODO:
#	int TAG_BR		or
	int TAG_FIELDSET or
	int TAG_OPTGROUP or
	int TAG_TABLE	or
	int TAG_TD		or
	int TAG_TR		=>	sys->print("unsupported: %s!\n", tagtostring(tree.tag));

	int TAG_SETVAR	or
	int TAG_POSTFIELD =>	;

 	int TAG_GO	or
 	int TAG_PREV	or
 	int TAG_NOOP	or
 	int TAG_REFRESH	=>		;
			
	int TAG_WML =>
		currenttemplate = nil;
		currentdeck = tree;
		drawsubtags(tree);

	int TAG_HEAD =>
		drawsubtags(tree);

	int TAG_ACCESS =>
		sys->fprint(stderr, "wmlbro: access tag not yet supported\n");

	int TAG_META =>
		if(debug)
		{
			sys->print("saw meta tag:\n");
			bt := load WmlLib WmlLib->PATH;
			s = bt->buildtextr("", tree);
			sys->print("%s", s);
		}

	int TAG_TEMPLATE =>
		currenttemplate = tree;

	# types: onenterforward, onenterbackward, ontimer
	int TAG_CARD =>
		if(currentcard != nil)
			return;
		title := "";
		for(i := 0; i < len tree.attribs; i++)
		{
			a := tree.getnthattr(i);
			case int a.tag
			{
			int ATT_TITLE =>
				title = a.text;
			int ATT_NEWCONTEXT_TRUE =>
				if(a.text == "true")
					newcontext();
			int ATT_ONTIMER =>				;
			int ATT_ONENTERBACKWARD =>
				if(isbackward)
					eventfired(a.tag);
			int ATT_ONENTERFORWARD =>
				if(isforward)
					eventfired(a.tag);
			}
		}
		tkcmd(".f.l configure -text {" + title + "}");
		currentcard = tree;
		drawsubtags(tree);
# TODO: this is where we have to do the overriding!
# remember what name's (for DO tags) and types (for onevent tags) have been done in card,
# and do only the ones in the template that haven't been done in card.
# see wml/template.wml
#
		if(currenttemplate != nil)
			drawsubtags(currenttemplate);

	int TAG_P =>
		newj := justify;
		for(i := 0; i < len tree.attribs; i++)
		{
			a := tree.getnthattr(i);
			case int a.tag
			{
			int ATT_ALIGN_LEFT or
			int ATT_ALIGN_CENTER or
			int ATT_ALIGN_RIGHT or
			int ATT_ALIGN =>
				newj = a.text;
			}
		}
		case newj
		{
		"right" =>	newj = "e";
		"center" =>	newj = "";
		* => newj = "w";
		}
		if(newj != justify)
		{
			if(justify != nil)
				packcmd += "-anchor " + justify;
			packcmd += " -side top";
			tkcmd(packcmd);
			packcmd = "pack ";
		}
		justify = newj;
		drawsubtags(tree);

	int TAG_TIMER =>
		value := int tree.getattr(ATT_VALUE);
		refcount++;
		spawn timertask(ATT_ONTIMER, ccid, value * 100);

	int TAG_OPTION =>
		inoption = 1;
		drawsubtags(tree);
		inoption = 0;

	int TAG_SELECT =>
		w := sys->sprint(".f.doc.li%d", lcount);
		lcount++;
		tkcmd("frame " + w);
		s = sys->sprint("scrollbar %s.scrolly -orient vertical -command {%s.l yview}", w, w);
		tkcmd(s);

		# crappy heuristic to set the height of the listbox
		height := 2;
		if(len tree.subtags > 4) height = 6;
		if(len tree.subtags > 8) height = 10;

		s = sys->sprint("listbox %s.l -height %dh -yscrollcommand {%s.scrolly set}", w, height, w);
		tkcmd(s);
		currentselect = w + ".l";
		drawsubtags(tree);
		s = sys->sprint("pack %s.scrolly -side right -fill y", w);
		tkcmd(s);
		s = sys->sprint("pack %s.l -fill both -expand 1", w);
		tkcmd(s);
		packcmd += w + " ";
		s = sys->sprint("bind %s.l <Button-1> +{send user pick %s}", w, w);
		tkcmd(s);
		tree.handle = w;
		currentlinks = tree :: currentlinks;

	int TAG_IMG =>
		fname : string;
		tag := sys->sprint("frame .f.doc.if%d", lcount);
		lcount++;
		tag = tkcmd(tag);
		for(i := 0; i < len tree.attribs; i++)
		{
			a := tree.getnthattr(i);
			case int a.tag
			{
			int ATT_SRC_HTTPS or
			int ATT_SRC_HTTP or
			int ATT_SRC =>
				fname = a.text;
			}
		}
		if(debug)
			sys->print("image tag: %s\n", fname);
		if(fname != nil)
		{
			u : ParsedUrl;
			u = *(url->makeurl(fname));
			u = applyrelative(u);

			refcount++;
			spawn requestthread(u, tag, TAG_IMG);

			if(justify != nil)
				packcmd += " -anchor " + justify;
			packcmd += " -side top";
			tkcmd(packcmd);
			packcmd = "pack " + tag + " -fill both -expand 1 -side top ";
			if(justify != nil)
				packcmd += "-anchor " + justify;
			tkcmd(packcmd);
			packcmd = "pack ";
		}

	int TAG_INPUT =>
		what := sys->sprint(".f.doc.e%d", lcount);
		lcount++;
		tkpswd := "";
		for(i := 0; i < len tree.attribs; i++)
		{
			a := tree.getnthattr(i);
			case int a.tag
			{
			int ATT_TYPE =>
				if(a.text == "password")
					tkpswd = "-show {*} ";
			int ATT_TYPE_PASSWORD =>
				tkpswd = "-show {*} ";
			# TODO:
			# int ATT_TYPE_TEXT =>
			# int ATT_VALUE =>
			# int ATT_FORMAT =>
			# int ATT_EMPTYOK_FALSE =>
			# int ATT_EMPTYOK_TRUE =>
			# int ATT_SIZE =>
			# int ATT_MAXLENGTH =>
			# int ATT_TABINDEX =>
			}
		}
		s = sys->sprint("entry %s -bg #aaaaaa %s", what, tkpswd);
		tkcmd(s);
		packcmd += what + " ";
		# binding FocusOut doesn't seem to work unless you
		# focus into another field, so i used "Key"
		s = sys->sprint("bind %s <Key> +{send user inputfocusout %s}", what, what);
		tkcmd(s);
		tree.handle = what;
		currentlinks = tree :: currentlinks;

	int TAG_ONEVENT	=>
		# onevent can be inside a card, template, or option
		# types: onenterforward, onenterbackward, ontimer
		# TODO: mask card onevents over template ones by *type* attribute
		for(i := 0; i < len tree.attribs; i++)
		{
			a := tree.getnthattr(i);
			case int a.tag
			{
			int ATT_TYPE =>
				case a.text
				{
				"onenterbackward" =>
					if(isbackward)
						eventfired(ATT_ONENTERBACKWARD);
				"onenterforward" =>
					if(isforward)
						eventfired(ATT_ONENTERFORWARD);
				}
			int ATT_TYPE_ONPICK =>				;
			int ATT_TYPE_ONTIMER =>				;
			int ATT_TYPE_ONENTERBACKWARD =>
				if(isbackward)
					eventfired(ATT_ONENTERBACKWARD);
			int ATT_TYPE_ONENTERFORWARD =>
				if(isforward)
					eventfired(ATT_ONENTERFORWARD);
			}
		}
		return;

	int TAG_DO =>
		# TODO: mask card DO tags over templete ones with the same *name* attribute
		what := sys->sprint(".f.doc.b%d", lcount);
		lcount++;
		label := escape(tree.getattr(ATT_LABEL));
		if(label == nil)
			label = tree.getattr(ATT_TYPE);
		if(label == nil)
			label = "Do";	# TODO, refer to spec on how to name DO widget.
		# TODO, should we do something different based on the type attribute?
		s = sys->sprint("button %s -text {%s} -command {send user go %s}",
			what, label, what);
		packcmd += what + " ";
		tkcmd(s);
		tree.handle = what;
		currentlinks = tree :: currentlinks;

	int TAG_A or
	int TAG_ANCHOR =>
		inanchor = 1;
		currentlink = tree;
		currentlinks = tree :: currentlinks;
		drawsubtags(tree);
		inanchor = 0;

	int TAG_PRE =>
		font = getvariable("!font_pre");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_SMALL =>
		font = getvariable("!font_small");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_STRONG =>
		font = getvariable("!font_strong");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_U =>
		font = getvariable("!font_underline");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_B =>
		font = getvariable("!font_bold");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_BIG =>
		font = getvariable("!font_big");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_EM =>
		font = getvariable("!font_emphasis");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int TAG_I =>
		font = getvariable("!font_italic");
		drawsubtags(tree);
		font = getvariable("!font_normal");

	int LITERAL_C =>
		addpcdata(tree);
	}
}

addpcdata(tree : ref TagNode)
{
	s : string;
	pcdata := escape(tree.text);
	what := sys->sprint(".f.doc.l%d", lcount); lcount++;

	if(inoption)
	{
		s = sys->sprint("%s insert end '%s", currentselect, pcdata);
		tkcmd(s);
		return;
	}
	if(inanchor)
	{
		s = sys->sprint("label %s -font %s -fg blue -text {%s}", what, font, pcdata);
		tkcmd(s);
		if(currentlink.handle == nil)
			currentlink.handle = what;
		s = sys->sprint("bind %s <ButtonRelease-1> {send user go %s}", what, currentlink.handle);
		tkcmd(s);
	}
	else
	{
		s = sys->sprint("label %s -font %s -text {%s}", what, font, pcdata);
	}
	tkcmd(s);
	packcmd += what + " ";
}

drawsubtags(tree : ref TagNode)
{
	ll := tree.subtags;
	while(ll != nil)
	{
		# this is the WML DTD validation

		if(dtdchecktag(tree.tag, (hd ll).tag))
			drawcard(hd ll);
		else
			sys->fprint(stderr, "%s should not have %s\n",
				tagtostring(tree.tag), tagtostring((hd ll).tag));
		ll = tl ll;
	}
}

appendtolist(ss : list of ref TagNode, s : ref TagNode) : list of ref TagNode
{
	if(tl ss == nil)
		return hd ss :: s :: nil;
	return hd ss :: appendtolist(tl ss, s);
}

# loads bookmarks file, parses it, adds the new link to the tree,
# rebuilds and saves it into bookmarks file

addbookmark(link : string)
{
	bmf := getvariable("!bookmarks");
	contents := string loadfile(openfile(bmf));
	if(contents != nil)
	{
		wp := load WmlLib WmlLib->PATH;
		wp->modinit();
		t := wp->parsetext(contents);
		if(debug > 1)
			wp->dumptree("", t);
		nil = wp;
		tnew := ref TagNode;

		ba := ref TagNode("", ATT_HREF, link, nil, nil) :: nil;
		linkpcdata := ref TagNode("", LITERAL_C, link, nil, nil) :: nil;
		tnew = ref TagNode("", TAG_A, nil, ba, linkpcdata);
		(hd (hd t.subtags).subtags).subtags = appendtolist((hd (hd t.subtags).subtags).subtags, tnew);
		tnew = ref TagNode("", TAG_BR, nil, nil, nil);
		(hd (hd t.subtags).subtags).subtags = appendtolist((hd (hd t.subtags).subtags).subtags, tnew);
		
		out := wp->buildtext(t);
		
		if((sfd := sys->open(bmf, Sys->OWRITE | Sys->OTRUNC)) != nil )
			sys->fprint(sfd, "%s", out);
		else
			sys->fprint(stderr, "failed to open %s: %r\n", bmf);
	}	
}

# '!' is not a legal char to start a WML variable name with, so we're safe
# to use it internally to store config parameters

readconfig()
{
	new := "";
	i := 0;
	s := string loadfile(openfile("config"));
	if(s != nil)
	{
		while(i < len s)
		{
			if(s[i] == '#')
			{
				while(i < len s && s[i] != '\n')
					i++;
			}
			new += s[i:i+1];
			i++;
		}
	}
	(n, ll) := sys->tokenize(new, "\n");
	while(ll != nil)
	{
		(n2, ww) := sys->tokenize(hd ll, "= \t");
		if(n2 > 1)
			setvariable("!" + hd ww, hd tl ww);
		ll = tl ll;
	}
}

nightrider()
{
	i := 0;
	dir := 1;
	s : string;

loop:
	while(1)
	alt
	{
	* =>
		sys->sleep(100);
		tkcmd(".f.f.nr delete 0 end");
		tkcmd(".f.f.nr create rectangle 0 0 39 15 -fill white");
		s = sys->sprint(".f.f.nr create rectangle %d 0 %d 15 -fill black", i * 5, i * 5 + 4);
		tkcmd(s + " ; update");
		if(dir)
		{
			i++;
			if (i == 7)
				dir = 0;
		}
		else
		{
			i--;
			if (i == 0)
				dir = 1;
		}
	k := <- nrchan =>
		break loop;
	}
	tkcmd(".f.f.nr delete 0 end ; update");
}

toggledebug()
{
	if(debugpanel)
	{
		debugpanel = 0;
		tkcmd("destroy .f.deb ; update");
	}
	else
	{
		debugpanel = 1;
		tkcmd("frame .f.deb");
		tkcmd("button .f.deb.b1 -text {dumpvars} -command {send user dumpvars}");
		tkcmd("button .f.deb.b2 -text {dumphist} -command {send user dumphist}");
		tkcmd("button .f.deb.b3 -text {dumpcache} -command {send user dumpcache}");
		tkcmd("pack .f.deb.b1 .f.deb.b2 .f.deb.b3 -side left");
		tkcmd("pack .f.deb ; pack .f ; update");
	}
}
