# vasil@vasil.com

implement WMLDecode;

include "sys.m";
include "draw.m";
include "wmlbro.m";
include "wml.m";
include "tagnode.b";

sys: Sys;
draw: Draw;
stderr: ref Sys->FD;
debug := 0;

include "loadfile.b";

init(nil: ref Draw->Context, argv: list of string)
{
	s : string;
	b : array of byte;

	modinit();
	argv = tl argv;
	while(argv != nil)
	{
		case (hd argv)
		{
		"-d" =>	debug = 1;
		* => s = hd argv;
		}
		argv = tl argv;
	}
	
	if(s != nil)
		b = loadfile(openfile(s));
	else
		b = loadfile(sys->fildes(0));

	if(b != nil)
	{
		s = decode(b);
		sys->print("%s", s);
	}
}

modinit()
{
	sys		= load Sys		Sys->PATH;
	draw	= load Draw		Draw->PATH;
	stderr = sys->fildes(2);
}

decode(b : array of byte) : string
{
	wp := load WmlLib WmlLib->PATH;
	wp->modinit();
	t := wp->parsebinary(b);
	if(debug)
		wp->dumptree("", t);
	s := wp->buildtext(t);
	nil = wp;
	return s;
}
