# vasil@vasil.com

# this encodes the WML DTD as a list as an array of
# tuples T, one for each type of WML tag.
# T consists of the tag's token, a list of tokens it
# may contain, and a list of attribute tokens it may
# contain. see below.
#
# TODO: find a smaller implementation, a 2D bitfield?
#

dtd : array of (byte, list of byte, list of byte);

dtdfindtag(b : byte) : (byte, list of byte, list of byte)
{
	i := 0;
	while(i < len dtd)
	{
		(tag, nil, nil) := dtd[i];
		if(tag == b)
			return dtd[i];
		i++;
	}
	if(debug)
		sys->print("did not find tag\n");
	return dtd[len dtd];
}

dtdchecktag(current, next : byte) : int
{
	t : (byte, list of byte, list of byte);
	ll : list of byte;
	t = dtdfindtag(current);
	(nil, nil, ll) = t;
	while(ll != nil)
	{
		if(hd ll == next)
			return 1;
		ll = tl ll;
	}
	if(debug)
		sys->print("returning 0 in dtdchecktag()\n");
	return 0;
}

dtdcheckattr(current, next : byte) : int
{
	t : (byte, list of byte, list of byte);
	ll : list of byte;
	t = dtdfindtag(current);
	(nil, ll, nil) = t;
	while(ll != nil)
	{
		if(hd ll == next)
			return 1;
		ll = tl ll;
	}
	if(debug)		
		sys->print("returning 0 in dtdcheckattr()\n");
	return 0;
}

dtdinit()
{

dtd = array [] of
{
(TAG_WML,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	:: nil),
	(TAG_HEAD
	::	TAG_TEMPLATE
	::	TAG_CARD
	:: nil)
),
(TAG_HEAD,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_ACCESS
	::	TAG_META
	::	nil)
),
(TAG_ACCESS,
	(ATT_DOMAIN
	::	ATT_PATH
	::	ATT_ID
	::	ATT_CLASS
	:: nil),
	nil
),
(TAG_META,
	(ATT_HTTP_EQUIV
	::	ATT_HTTP_EQUIV_CONTENT_TYPE
	::	ATT_HTTP_EQUIV_EXPIRES
	::	ATT_NAME
	::	ATT_FORUA_FALSE
	::	ATT_FORUA_TRUE
	::	ATT_CONTENT
	::	ATT_CONTENT_AVWW
	::	ATT_SCHEME
	::	ATT_ID
	::	ATT_CLASS
	:: nil),
	nil
),
(TAG_TEMPLATE,
	(ATT_ONENTERBACKWARD
	::	ATT_ONENTERFORWARD
	::	ATT_ONTIMER
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_DO
	::	TAG_ONEVENT
	::	nil)
),
(TAG_CARD,
	(ATT_TITLE
	::	ATT_NEWCONTEXT_FALSE
	::	ATT_NEWCONTEXT_TRUE
	::	ATT_ORDERED_TRUE
	::	ATT_ORDERED_FALSE
	::	ATT_XML_LANG
	::	ATT_ONENTERBACKWARD
	::	ATT_ONENTERFORWARD
	::	ATT_ONTIMER
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_ONEVENT
	::	TAG_TIMER
	::	TAG_DO
	::	TAG_P
	::	TAG_PRE
	::	nil)
),
(TAG_DO,
	(ATT_TYPE
	::	ATT_TYPE_ACCEPT
	::	ATT_TYPE_DELETE
	::	ATT_TYPE_HELP
	::	ATT_TYPE_OPTIONS
	::	ATT_TYPE_PREV
	::	ATT_TYPE_RESET
	::	ATT_TYPE_VND
	::	ATT_LABEL
	::	ATT_NAME
	::	ATT_OPTIONAL_FALSE
	::	ATT_OPTIONAL_TRUE
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_GO
	::	TAG_PREV
	::	TAG_NOOP
	::	TAG_REFRESH
	::	nil)
),
(TAG_ONEVENT,
	(ATT_TYPE
	::	ATT_TYPE_ONPICK
	::	ATT_TYPE_ONENTERBACKWARD
	::	ATT_TYPE_ONENTERFORWARD
	::	ATT_TYPE_ONTIMER
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_GO
	::	TAG_PREV
	::	TAG_NOOP
	::	TAG_REFRESH
	::	nil)
),
(TAG_TIMER,
	(ATT_NAME
	::	ATT_VALUE
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_P,
	(ATT_ALIGN
	::	ATT_ALIGN_CENTER
	::	ATT_ALIGN_LEFT
	::	ATT_ALIGN_RIGHT
	::	ATT_MODE_NOWRAP
	::	ATT_MODE_WRAP
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(LITERAL_C
	::	TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	TAG_INPUT
	::	TAG_SELECT
	::	TAG_FIELDSET
	::	TAG_DO
	::	nil)
),
(TAG_PRE,
	(ATT_XML_SPACE_PRESERVE
	::	ATT_XML_SPACE_DEFAULT
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(LITERAL_C
	::	TAG_A
	::	TAG_BR
	::	TAG_I
	::	TAG_B
	::	TAG_EM
	::	TAG_STRONG
	::	TAG_INPUT
	::	TAG_SELECT
	::	nil)
),
(TAG_GO,
	(ATT_HREF
	::	ATT_HREF_HTTP
	::	ATT_HREF_HTTPS
	::	ATT_SENDREFERER_FALSE
	::	ATT_SENDREFERER_TRUE
	::	ATT_METHOD_GET
	::	ATT_METHOD_POST
	::	ATT_ENCTYPE
	::	ATT_ENCTYPE_APP_X_W3_URLENCODED
	::	ATT_ENCTYPE_MULTIPART_FORM_DATA
	::	ATT_ACCEPT_CHARSET
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_POSTFIELD
	::	TAG_SETVAR
	::	nil)
),
(TAG_PREV,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_SETVAR
	::	nil)
),
(TAG_REFRESH,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_SETVAR
	::	nil)
),
(TAG_NOOP,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_EM,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_STRONG,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_B,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_I,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_U,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_BIG,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_SMALL,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	LITERAL_C
	::	nil)
),
(TAG_BR,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_IMG,
	(ATT_ALT
	::	ATT_SRC
	::	ATT_SRC_HTTP
	::	ATT_SRC_HTTPS
	::	ATT_LOCALSRC
	::	ATT_VSPACE
	::	ATT_HSPACE
	::	ATT_ALIGN
	::	ATT_ALIGN_BOTTOM
	::	ATT_ALIGN_MIDDLE
	::	ATT_ALIGN_TOP
	::	ATT_HEIGHT
	::	ATT_WIDTH
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_ANCHOR,
	(ATT_TITLE
	::	ATT_ACCESSKEY
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_BR
	::	TAG_IMG
	::	TAG_GO
	::	TAG_PREV
	::	TAG_REFRESH
	::	LITERAL_C
	::	nil)
),
(TAG_A,
	(ATT_HREF
	::	ATT_HREF_HTTP
	::	ATT_HREF_HTTPS
	::	ATT_TITLE
	::	ATT_ACCESSKEY
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_BR
	::	TAG_IMG
	::	LITERAL_C
	::	nil)
),
(TAG_TABLE,
	(ATT_TITLE
	::	ATT_ALIGN
	::	ATT_ALIGN_CENTER
	::	ATT_ALIGN_LEFT
	::	ATT_ALIGN_RIGHT
	::	ATT_COLUMNS
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_TR
	::	nil)
),
(TAG_TR,
	(ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_TD
	::	nil)
),
(TAG_TD,
	(ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	LITERAL_C
	::	nil)
),
(TAG_INPUT,
	(ATT_NAME
	::	ATT_TYPE
	::	ATT_TYPE_PASSWORD
	::	ATT_TYPE_TEXT
	::	ATT_VALUE
	::	ATT_FORMAT
	::	ATT_EMPTYOK_FALSE
	::	ATT_EMPTYOK_TRUE
	::	ATT_SIZE
	::	ATT_MAXLENGTH
	::	ATT_TABINDEX
	::	ATT_TITLE
	::	ATT_ACCESSKEY
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_SELECT,
	(ATT_TITLE
	::	ATT_NAME
	::	ATT_VALUE
	::	ATT_INAME
	::	ATT_IVALUE
	::	ATT_MULTIPLE_FALSE
	::	ATT_MULTIPLE_TRUE
	::	ATT_TABINDEX
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_OPTGROUP
	::	TAG_OPTION
	::	nil)
),
(TAG_FIELDSET,
	(ATT_TITLE
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_EM
	::	TAG_STRONG
	::	TAG_B
	::	TAG_I
	::	TAG_U
	::	TAG_BIG
	::	TAG_SMALL
	::	TAG_BR
	::	TAG_IMG
	::	TAG_ANCHOR
	::	TAG_A
	::	TAG_TABLE
	::	TAG_INPUT
	::	TAG_SELECT
	::	TAG_FIELDSET
	::	TAG_DO
	::	LITERAL_C
	::	nil)
),
(TAG_POSTFIELD,
	(ATT_NAME
	::	ATT_VALUE
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_SETVAR,
	(ATT_NAME
	::	ATT_VALUE
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	nil
),
(TAG_OPTGROUP,
	(ATT_TITLE
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_OPTGROUP
	::	TAG_OPTION
	::	nil)
),
(TAG_OPTION,
	(ATT_VALUE
	::	ATT_TITLE
	::	ATT_ONPICK
	::	ATT_XML_LANG
	::	ATT_ID
	::	ATT_CLASS
	::	nil),
	(TAG_ONEVENT
	::	LITERAL_C
	::	nil)
),
(byte 0, nil, nil)

};
 
}