# vasil@vasil.com

implement WMLEncode;

include "sys.m";
include "draw.m";
include "wmlbro.m";
include "wml.m";
include "tagnode.b";

sys: Sys;
draw: Draw;
stderr: ref Sys->FD;
debug := 0;

include "loadfile.b";

init(nil: ref Draw->Context, argv: list of string)
{
	s : string;

	modinit();
	argv = tl argv;
	while(argv != nil)
	{
		case (hd argv)
		{
		"-d" =>	debug = 1;
		* => s = hd argv;
		}
		argv = tl argv;
	}
	
	if(s != nil)
		s = string loadfile(openfile(s));
	else
		s = string loadfile(sys->fildes(0));

	if(s != nil)
	{
		b := encode(s);
		sys->write(sys->fildes(1), b, len b);
	}
}

modinit()
{
	sys		= load Sys		Sys->PATH;
	draw	= load Draw		Draw->PATH;
	stderr = sys->fildes(2);
}

encode(s : string) : array of byte
{
	wp := load WmlLib WmlLib->PATH;
	wp->modinit();
	t := wp->parsetext(s);
	if(debug)
		wp->dumptree("", t);
	b := wp->buildbinary(t);
	nil = wp;

	return b;
}
